# Funky-emv

### 2.0.0 - 2020-07-22

- Update cloudwalk (2.0.0) mruby 2.1.0;

### 1.4.1 - 2020-06-22

- return from select if timeout value was set on mruby-emv;

### 1.4.0 - 2020-06-17

- Implemented start_check_event and check_event to check for card and keyboard events;
- Fixed bug on check_event, it wasn't considering when operator was pressing CANCEL.

### 1.3.1 - 2020-06-15

- Replace emv_wait to emv_processing image display.

### 1.3.0 - 2020-06-01

- Check nil? and empty? on credit and debit appplications;
- Implemented Device::EMVRow#ctls?;
- Added support to retrieve applications that have contactless support.

### 1.2.2 - 2019-12-18

- Fixed tags size calculation on EmvSharedLibrary#merge_tags

### 1.2.1 - 2019-07-06

- Fixed issue with magnetic card swiped, shared library is not returning magnetic stripe data

### 1.2.0 - 2019-06-25

- Implement pre selection of credit and debit applications.

### 1.1.0 - 2019-06-18

- Support to load information from Json on init_data structure;
- Support to build custom parameters on EmvTransaction.params.

### 1.0.0 - 2019-06-18

- Support CTLS emv table;
- Support CTLS operation;
- Added CTLS attribute in init_info structure;

### 0.26.0 - 2019-06-06

- Refactoring json parameters use on EmvTransaction::open to support emv parameters share between ruby applications;
- Store selection result in init_info struct as result key.

### 0.25.0 - 2019-05-29

- Replaced waiting to emv_wait;
- Fix tag 4F removal on EmvSharedLibrary.

### 0.24.0 - 2019-05-22

- Support backup emv_acquirer_aid load;
- Implement EmvTransaction::boot to open, clean and load tables;
- Implement EmvTransaction::reboot to close and open handle;
- Implement EmvTransaction::set_initial_data to define time operation.

### 0.23.5 - 2019-05-10

- Fix acquirer_id addition at EmvSharedLibrary.

### 0.23.4 - 2019-05-07

- Fix possible format error at acquirer id on EmvSharedLibrary.

### 0.23.3 - 2019-04-16

- Bug fix setup return (integer type needed) when pax.

### 0.23.2 - 2019-04-16

- Remove unnecessary usleep during pin entry.

### 0.23.1 - 2019-04-15

- Fix image corruption adopting a wait time between input display at FunkyEmv::UI::display.

### 0.23.0 - 2019-04-09

- EmvSharedLibrary: Reduce timeout on process loop getc;
- EmvSharedLibrary: display waiting image after go on chip;
- Support icc detection to PAX EmvSharedLibrary devices;
- Always EmvSharedLibrary to EmvTransaction.

### 0.22.0 - 2019-03-27

- Refactoring displays and wait screen timeout to speed up transaction flow.

### 0.21.0 - 2019-03-14

- Support custom selection image.

### 0.20.2 - 2019-02-05

- Bug fix blanked screen before pin entry on PAX.

### 0.20.1 - 2018-10-10

- Refactoring EmvSharedLibrary to check tag 4F after 9F06 at go on chip process to return AID.

### 0.20.0 - 2018-10-03

- Add FunkyEmv Ui to display remove card message on Shared Library interface.

### 0.19.0 - 2018-09-21

- Removed skeleton test and move table file test to shared.
- Update cloudwalk (1.11.2).
- Add tag 06 to default list.
- Fix runtime int division error on finish tag calculation.
- Implement EMV DOL parser and validation.

### 0.18.1 - 2018-09-18

- Fix EmvSharedLibrary finish tags len.

### 0.18.0 - 2018-09-17

- Refactoring SharedLibrary prints adopting Device::Display and only printing Notification when not dealing with ingenico terminals.
- Fix ShreadLibrary process input string adjusting with 0 padding.
- Fix finish and process input tags len.
- Add adjust to ingenico terminals at SharedLibrary:
    - Remove mandatory tags
    - Replace ddol and tdol values during load tables

### 0.17.2 - 2018-08-09

- Add sleep before call pin methods to avoid problems on display and memory location of PAX EMV Kernel.

### 0.17.1 - 2018-07-02

- Set rgb 0,0,0 when font.dat doesn’t exists at Pax.

### 0.17.0 - 2018-05-18

- Implement cvm parse and refactoring some debugs.
- PAX: Bug fix verify_cupher_pin return.
- PAX: Expect ERR_PED_NO_KEY(-3801) to dukpn pin block exec.

### 0.16.2 - 2018-01-26

- Return PPCOMP_ERRPIN when PAX::Pinpad::ERR_PED_GROUP_IDX_ERR during pin dukpt input.

### 0.16.1 - 2018-01-18

- Fix get pin plain (offline) variable return the variable wasn’t being checked.
- Return shared library value to PAX user cancel return.

### 0.16.0 - 2018-01-16

- Only display emv remove card message if card still present.
- Implement class responsible to perform Ui and add support to display image for pin entry and remove card.

### 0.15.0 - 2018-01-04

- Replace Device::ParamsDat for DaFunk::ParamsDat.
- Replace Device::Helper for DaFunk::Helper (da_funk 1.0.0).

### 0.14.0 - 2017-11-28

- Implement custom RGB for pins input on PAX.

### 0.13.0 - 2017-10-30

- Check ICC RSP6985 at process transaction on pax flow.

### 0.12.0 - 2017-10-23

- Refactoring selection menu to avoid the same label.

### 0.11.0 - 2017-10-10

- Implement Row#accurate_aid to support length check.
- Fix aid row comparison checking length on all situations.

### 0.10.0 - 2017-09-26

- Check emv_application_name_table for application label display.

### 0.9.1 - 2017-09-06

- Fix string memory leak at application name display.

### 0.9.0 - 2017-09-06

- Add sleep time after application name display.
- Check params dat flag emv_application_name_table to show application name from table.

### 0.8.0 - 2017-08-10

- Support to ICC_CMD_ERR on EmvPax.
- Remove application version debug.
- Change Funky-EMV license.

### 0.7.0 - 2017-08-02

- Get AID from table row on SharedLibrary during the init.
- Get tag 9F06 to set AID when EMVShared library.
- Get tag 9F06 to set AID when EMVPax.
- Send aid from 9f06 if isn’t necessary to delete tag too.
- Remove EmvSharedLibrary.go_on_chip_tlv_result debugs.
- Fix EmvPax.get_aid_tlv getting the correct tags (4F and 9F12).

### 0.6.0 - 2017-07-19

- Fix finish tags generation.

### 0.5.9 - 2017-07-13

- Remove extra “F” when get tag 5A(PAN).

### 0.5.8 - 2017-06-01

- Add check to tlv content before finish transaction script process.

### 0.5.7 - 2017-03-29

- Refactoring emv_pax kernel to BC errors to support PPCOMP_ERRFALBACK.

### 0.5.6 - 2017-01-16

- Define EmvTransaction.opened as false when close is called to fix Gertec second transaction.

### 0.5.5 - 2016-12-30

- Check if block is given on get_pin_block to check attempts.
- Fix I18n entry, emv_pin_locked by emv_pin_blocked.
- Refactoring get_pin_block callback during attempts check for offline pin.
- Implement version check based in the card application read.
- [PAX] Refactoring timeout error check in select_loop.

### 0.5.4 - 2016-12-27
- Refactoring decision[“RETURN”] check after start_transaction to avoid return wrong value.
- Do not open EmvTransaction if already open.
- Fix read attempts process during read smart card.
- Return PPCOMP_CARDINVALIDAT instead of PPCOMP_CARDBLOCKED if ICC_BLOCK during app selection(smartcard read).

### 0.5.3 - 2016-12-26
- Bug fix on PAN conversion on DUKPT process.
- Bug fix on block and ksn conversion on DUKPT process.
- Bug fix on EMV generate_tags process.

### 0.5.2 - 2016-12-19
- Bug fix process floor limit at EmvSharedLibrary.

### 0.5.1 - 2016-12-15
- Added emv_pin_locked message.
- EMVPax - Added logic to display a message when the PIN try limit was exceeded, it's required on ADVT 22 test case.
- EMVPax - Added logic to display a message when the PIN try limit was exceeded, it's required on ADVT 21 test case.

### 0.5.0 - 2016-12-15
- Replace icc.detected by self.decteted at EmvPax and force use internal abstraction.
- Refactor timestamp set in SharedLibrary table initialisation.
- Refactor select process (get_card) to abort transaction if any problem and avoid error 10(INVALCALL) on next call.
- Print label is not necessary in SharedLIbrary.
- Abort transaction EMVSharedLibrary.process if any problem.
- Refactor all input parse in EMVSharedLibrary.
- Add CTLS entry for ProcessInfo in EMVSharedLibrary.
- EMVSharedLibrary became more stable.

### 0.4.6 - 2016-12-01
- Bug fix forgot to initialize table.

### 0.4.5 - 2016-11-29
- Bug fix typo processing initialization input.
- Send the smart card detection responsibility to EMV platform classes.
- Bug fix load table sending the correct timestamp.

### 0.4.4 - 2016-11-24
- Refactoring EmvSharedLibrary class supporting entire EMV flow.
- Replace Platform call by Device.
- Call Device::EMV.init instead of Device::EMV.open on EmvSharedLibrary setup process, which support open.
- Bug fix check if PAX class to use shared library.

### 0.4.3 - 2016-11-04
- Bug fix select_loop when it returns ICC_CMD_ERR for the first time.

### 0.4.2 - 2016-10-06
- Always delete all keys before insert the selected ones.
- Implement the check of cyrillic char during application label display.
- Bug fix treat user cancel during application selection.

### 0.4.1 - 2016-10-06
- Displat tag 0x50 if tag 9F12 is empty at selection.
- Bug fix return unless scheme fond in EmvRow parse.
- Bug fix create hash before check tlv in finish.

### 0.4.0 - 2016-10-03
- Fix script processing sending to TLV command only what EMVCompleteTrans require.
- Change POS Entry for 0x04.
- Display clear after get_pin functions.
- Replace 0x9C(Transaction Type) from EMV_PAYMENT(0x40) EMV_GOODS&EMV_CASH (0x00)
- Implement InitData.localtion_mode.
- Add EmvTransaction.to_json/from_json methods to serialise and deserialise data and info structures.
- Add refund to process_data.
- Delete and load pki’s keys on every transaction.
- Set tlv 0x8A from self.finish_data.auth_resp_code at EmvPax.finish
- Remove ICC Application Usage Control definition.
- Do not generate tags map in load time, but pre define in ruby to improve performance.
- Refactoring lines and row to display application label.
- Add EmvRow#string
- Support to start EmvStruct with pre defined values.
- Bug fix doesn’t call set_tlv for amount_other if the value is 0.
- Refactoring all returns at EmvPax to use values from biblioteca compartilhada.
- Return PPCOMP_TABERR if problem to load any table row.
- Review timeouts and commentaries at pin block callbacks.
- Refactoring selection block using menu function from helper and return values from constants of PAX::EMV.
- Delete pkis before read tables.
- Use random to generate Unpredictable Number.
- Indent emv_pax.rb.
- Review get_pin_block clear and message display.
- Clear display after print :emv_not_accept.
- Add 200 milliseconds sleep time before call any get pin function to fix display problems.
- Replace application label tag from 0x50 to 0x9F12.

### 0.3.2 - 2016-09-08
- Remove da_funk from gemspec.

### 0.3.1 - 2016-09-06
- Refactoring pin enter to show incorrect pin message correctly.

### 0.3.0 - 2016-09-06
- Return row index on Pax Initialize interface.
- Refactoring commentaries and returns to posxml posxml interface.
- Turn funky-tlv and da_funk a dependency for dev and prod.
- Add emv_not_accept and emv_select_application i18n.
- Add PPCOMP returns to EmvPax.
- Add configuration process to change PAX custom select block.
- Separate read tables(emv_acquirer_aids) and load tables(PAX SDK Load).
- Call Device::PAX.init on EmvPax#initialize only.
- Remove EmvPAx#set_tag comentaries.
- Refactoring debugs in EmvPax.
- Add external_number_len, cardholder_name_len and application_label_len on EmvTransaction::InitData class.
- Add EmvTransaction.table= method.
- Support hardware parameter on EmvTransaction.open to load or not EMV hardware.
- EmvTransaction.open configure EMV class on Device form adapter.
- Call super on EmvTransaction methods.
- Refactoring app selection to support defined timeout.
- Remove debugs from load tables.
- Remove money input from process.
- Refactoring env structure set’s and get’s.
- Refactoring pax env finish method.
- Remove dynamically EMV class definition, now the responsibility belongs to mruby-pax.
- Remove host_decision and process_decision from EmvTransaction, we should use emv structures.
- Refactoring selection to follow shared library returns.
- Remove commentaries.
- Sent amount other to PAX::EMV.start_transaction.
- Refactoring PAX::EMV.finish setting TLV values from finish_data, and fix Device::EMV typo.
- Indent EmvTransaction.
- Refactoring EMVRow to check if keys include in the scheme and avoid exception.
- Include DaFunk::Helper in EmvPax.
- Implement EmvTransaction#opened?.
- Refactoring EmvPax#set_date packing only 6 bytes and parsing time using sprintf.
- Replace Struct use by EMVStruct to avoid memory leak.
- Add I18n for pin scenarios.
- Return EMV_CARDAPPNAV instead of EMV_NOAPPLIC when application no found in EmvPax selection.
- Review all commentaries in EmvPax.
- Add pin callback customization for get_pin_block, get_pin_plain and get_pin_dukpt.
- Set self.process_info.offline_pin and self.process_info.online_pin as default “0”.
- Implement EmvPax#amount_to_money converting value for currency based on transaction_currency_code.
- Check AC of start_transaction response.
- Support to ARQC in EmvPax#check_ac.
- Review pack/unpack action sending the total size, instead of use * and avoid possible memory leak.
- Refactoring EmvPax#finish:
  - Refactoring tlv and script receive, process and response.
  - Support to debug TSI.
  - Refactoring commentaries.
- Call Display.clear before print remove card.
- Debug application label and row label.

### 0.2.0 - 2016-06-30

- Support PAX D200 interface.

### 0.1.0 - 2016-06-29

- First version.