# coding: utf-8
lib = File.expand_path('../lib', __FILE__)
$LOAD_PATH.unshift(lib) unless $LOAD_PATH.include?(lib)

require 'version.rb'

Gem::Specification.new do |spec|
  spec.name          = "funky-emv"
  spec.version       = FunkyEmv::VERSION
  spec.authors       = ["Thiago Scalone"]
  spec.email         = ["thiago@cloudwalk.io"]
  spec.summary       = "DaFunk EMV Library"
  spec.description   = "Library responsible for implement the interface between EMV embedded sdk."
  spec.homepage      = "http://cloudwalk.io"
  spec.license       = "MIT"

  spec.files         = %w(.gitignore Gemfile Gemfile.lock README.md RELEASE_NOTES.md Rakefile funky-emv.gemspec lib/version.rb out/funky-emv/main.mrb)
  spec.executables   = []
  spec.test_files    = spec.files.grep(%r{^(test)/})
  spec.require_paths  = ["lib"]
  spec.required_ruby_version = '>= 1.9.3'

  spec.add_development_dependency "bundler", "~> 2.0"
  spec.add_development_dependency "rake", "~> 10.0"
  spec.add_dependency "funky-tlv", "~> 0.2"
end

